ADS.Core/ADS.Core/Controllers/AdvogadoController.cs
using ADS.Core.Model;
using ADS.Core.Unit;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ADS.Core.Controllers
{
    public class AdvogadoController : Controller
    {
        private UnitOfwork _unit = new UnitOfwork(); 
        private Advogado adv = new Advogado();
        private IList<Endereco> enderecos;
        private IList<Telefone> telefones;
        private IList<Veiculo> veiculos;
        private Dictionary<int, bool> idsSelecionados = new Dictionary<int, bool>();

        public ActionResult Importar()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Importar(HttpPostedFileBase uploadFile)
        {
            int cadastrados = 0;
            int atualizados = 0;
            try
            {
                if (uploadFile.ContentLength > 0)
                {
                    string filePath = Path.Combine(HttpContext.Server.MapPath("../Uploads"),
                   Path.GetFileName(uploadFile.FileName));
                    uploadFile.SaveAs(filePath);
                    DataSet ds = new DataSet();

                    //A 32-bit provider which enables the use of
                    string connectionString = string.Format("Provider=Microsoft.ACE.OLEDB.12.0;Data Source={0};Extended Properties=\"Excel 12.0 Xml;HDR=Yes;IMEX=1\";", filePath);

                    using (OleDbConnection conn = new System.Data.OleDb.OleDbConnection(connectionString))
                    {
                        conn.Open();
                        using (DataTable dtExcelSchema = conn.GetSchema("Tables"))
                        {
                            string sheetName = dtExcelSchema.Rows[0]["TABLE_NAME"].ToString();
                            string query = "SELECT * FROM [" + sheetName + "]";
                            OleDbDataAdapter adapter = new OleDbDataAdapter(query, conn);
                            //DataSet ds = new DataSet();
                            adapter.Fill(ds, "Items");
                            if (ds.Tables.Count > 0)
                            {
                                if (ds.Tables[0].Rows.Count > 0)
                                {
                                    for (int i = 0; i < ds.Tables[0].Rows.Count; i++)
                                    {
                                        if (string.IsNullOrEmpty(ds.Tables[0].Rows[i]["NumeroCarteira"].ToString()))
                                        {
                                            break;
                                        }
                                        Advogado adv = new Advogado()
                                        {
                                            Nome = ds.Tables[0].Rows[i]["Nome"].ToString(),
                                            RG = ds.Tables[0].Rows[i]["RG"].ToString(),
                                            CPF = ds.Tables[0].Rows[i]["CPF"].ToString(),
                                            NumeroCarteira = Convert.ToInt64(ds.Tables[0].Rows[i]["NumeroCarteira"].ToString().Trim()),
                                            NumeroInscricao = Convert.ToInt64(ds.Tables[0].Rows[i]["NumeroInscricao"].ToString().Trim()),
                                            Seccional = ds.Tables[0].Rows[i]["Seccional"].ToString(),
                                            Subsecao = ds.Tables[0].Rows[i]["Subseccao"].ToString(),
                                            Ativo = ds.Tables[0].Rows[i]["Ativo"].ToString().Trim().ToUpper() == "SIM" ? true : false,
                                            Veiculo = new List<Veiculo>(),
                                            Endereco = new List<Endereco>(),
                                            Telefone = new List<Telefone>(),
                                            CriadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"))
                                        };
                                        var result = _unit.AdvogadoRepository.BuscarPor(a => a.NumeroInscricao == adv.NumeroInscricao && a.Removido == false);

                                        if (result.Count > 0)
                                        {
                                            result.FirstOrDefault().Nome = adv.Nome;
                                            result.FirstOrDefault().RG = adv.RG;
                                            result.FirstOrDefault().CPF = adv.CPF;
                                            result.FirstOrDefault().NumeroCarteira = adv.NumeroCarteira;
                                            result.FirstOrDefault().NumeroInscricao = adv.NumeroInscricao;
                                            result.FirstOrDefault().Seccional = adv.Seccional;
                                            result.FirstOrDefault().Subsecao = adv.Subsecao;
                                            result.FirstOrDefault().Ativo = adv.Ativo;
                                            result.FirstOrDefault().AtualizadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                                            foreach (var v in result.FirstOrDefault().Veiculo)
                                            {
                                                v.Modelo = _unit.ModeloRepository.Buscar(v.ModeloId);
                                            }
                                            atualizados++;
                                            _unit.AdvogadoRepository.Alterar(result.FirstOrDefault());
                                        }
                                        else
                                        {
                                            cadastrados++;
                                            _unit.AdvogadoRepository.Cadastrar(adv);
                                        }
                                        _unit.Salvar();
                                        //Now we can insert this data to database...
                                    }
                                }
                            }
                        }
                    }
                }
                TempData["msg"] = "Inseridos: " + cadastrados + " Atualizados: " + atualizados;
                return RedirectToAction("Listar");
            }catch(Exception e)
            {
                TempData["msg"] = "Erro ao importar lista. " + e.Message;
                return RedirectToAction("Importar");
            }
            
        }

        [HttpGet]
        public ActionResult Cadastrar()
        {
            adv.Endereco = new List<Endereco>();
            adv.Veiculo = new List<Veiculo>();
            adv.Telefone = new List<Telefone>();
            CarregarListaFabricantes();
            ViewBag.modelos = new SelectList(new List<Modelo>());
            enderecos = new List<Endereco>();
            telefones = new List<Telefone>();
            veiculos = new List<Veiculo>();
            Session["enderecos"] = enderecos;
            Session["telefones"] = telefones;
            Session["veiculos"] = veiculos;
            return View(adv);
        }

        [HttpGet]
        public ActionResult Editar(int id)
        {
            CarregarListaFabricantes();
            ViewBag.modelos = new SelectList(new List<Modelo>());
            enderecos = new List<Endereco>();
            telefones = new List<Telefone>();
            veiculos = new List<Veiculo>();
            Session["enderecos"] = enderecos;
            Session["telefones"] = telefones;
            Session["veiculos"] = veiculos;
            var adv = _unit.AdvogadoRepository.Buscar(id);
            Session["enderecos"] = adv.Endereco.Where(e => e.Removido == false).ToList();
            Session["telefones"] = adv.Telefone;
            adv.Veiculo = (IList<Veiculo>)_unit.VeiculoRepository.BuscarPor(v => v.Advogado.AdvogadoId == adv.AdvogadoId);
            Session["veiculos"] = adv.Veiculo;
            return View(adv);
        }

        [HttpPost]
        public ActionResult Editar(Advogado advogado)
        {
            advogado.Endereco = (List<Endereco>)Session["enderecos"];
            advogado.Telefone = (List<Telefone>)Session["telefones"];
            advogado.Veiculo = (List<Veiculo>)Session["veiculos"];
            advogado.AtualizadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
            advogado.RemovidoEm = null;
            advogado.ExpedidoEm = null;
            foreach (var e in advogado.Endereco)
            {
                if (e.EnderecoId == 0)
                {
                    e.CriadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    e.AdvogadoId = advogado.AdvogadoId;
                    _unit.EnderecoRepository.Cadastrar(e);                    
                }
                else
                {
                    e.AtualizadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    e.AdvogadoId = advogado.AdvogadoId;
                    e.Advogado = null;
                    _unit.EnderecoRepository.Alterar(e);
                }          
            }
            foreach (var e in advogado.Telefone)
            {
                if(e.TelefoneId == 0)
                {
                    e.CriadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    e.AdvogadoId = advogado.AdvogadoId;
                    _unit.TelefoneRepository.Cadastrar(e);
                }
                else
                {
                    e.AtualizadoEm = Convert.ToDateTime(System.DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss"));
                    e.AdvogadoId = advogado.AdvogadoId;
                    e.Advogado = null;
                    _unit.TelefoneRepository.Alterar(e);

ADS.Core/ADS.Core/Views/Advogado/Importar.cshtml
@{
    ViewBag.Title = "Importar";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Importar</h2>

<div>
    @using (Html.BeginForm("Importar", "Advogado", FormMethod.Post, new { enctype = "multipart/form-data" }))
    {
        <input name="uploadFile" type="file"/>
        <br />
        <input type="submit" value="Importar Arquivo" title="Importar Arquivo" onclick="return (CheckFileName())" class="btn btn-default" />
    }
</div>

@section VerificarExtensaoExcel {
    <script type="text/javascript">
        function CheckFileName() {
            var fileName = document.getElementById("uploadFile").value
            alert(filename);
            if (fileName == "") {
                alert("Browse to upload a valid File with xls / xlsx extension");
                return false;
            }
            else if (fileName.split(".")[1].toUpperCase() == "XLS" || fileName.split(".")[1].toUpperCase() == "XLSX")
                return true;
            else {
                alert("File with " + fileName.split(".")[1] + " is invalid. Upload a validfile with xls / xlsx extensions");
                return false;
            }
            return true;
        }
</script>
}

ADS.Core/ADS.Core/Views/Advogado/Listar.cshtml
@model IEnumerable<ADS.Core.Model.Advogado>

@{
    ViewBag.Title = "Listar";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Listar Advogados</h2>

    <div class="row margem-abaixo">
        <div class="col-md-10">
            <span class="input-group-btn">
                <a href="@Url.Action("Cadastrar", "Advogado")" class="btn btn-primary"><i class="fa fa-plus"></i> Adicionar</a>
                <a href="@Url.Action("Importar", "Advogado")" class="btn btn-primary"><i class="fa fa-plus"></i> Importar</a>
                <a href="@Url.Action("Remover", "Advogado")" class="btn btn-primary"><i class="fa fa-remove"></i> Remover</a>
                <a href="#" class="btn btn-primary"><i class="fa fa-search"></i> Procurar</a>
            </span>
        </div>
    </div>
<table class="table table-responsive table-striped">
    <tr>
        <th><input type="checkbox" name="selectAll" id="selecionarTodos"/></th>
        <th>
            Nome
        </th>
        <th>
            @Html.DisplayNameFor(model => model.CPF)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.RG)
        </th>
        <th>
            Nr. Inscrição
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Seccional)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Subsecao)
        </th>       
        <th>
            @Html.DisplayNameFor(model => model.Ativo)
        </th>     
        <th></th>
    </tr>
    
@foreach (var item in Model) {
    <tr>
        <td>
            @Html.CheckBox("chkAdv", false, new { id = item.AdvogadoId })
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Nome)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.CPF)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.RG)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.NumeroInscricao)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Seccional)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Subsecao)
        </td>       
        <td>
            @Html.DisplayFor(modelItem => item.Ativo)
        </td>
        <td>
            <a href="../Advogado/Editar/@item.AdvogadoId" onclick="editarAdvogado()" id=@item.AdvogadoId class="glyphicon glyphicon-pencil btn btn-primary btn-xs"></a>
            <a href="#a" onclick="detalhesAdvogado(@item.AdvogadoId)" id=@item.AdvogadoId class="glyphicon glyphicon-eye-open btn btn-default btn-xs"></a>
            <a href="#a" onclick="return confirm('Deseja remover esse registro?') ? removerAdvogado(@item.AdvogadoId) : '';" id=@item.AdvogadoId class="glyphicon glyphicon-remove btn btn-danger btn-xs"></a>

        </td>
    </tr>
}
</table>



@RenderPage("~/Views/Shared/_Paginacao.cshtml")

<!-- MODAIS -->
<!-- Detalhes Advogado-->
<div class="modal fade" id="modalDetalhesAdvogado" tabindex="-1" role="dialog" aria-labelledby="Detalhes Advogado">
    <div class="modal-dialog" role="document">
        <div class="modal-content" id="detalhesAdvogadoBody">
            
        </div>
    </div>
</div>
@section ScriptListarAdvJs {
    <script src="~/Scripts/ListarAdvJs.js"></script>
}

ADS.Core/ADS.Core/Views/Advogado/_DetalhesAdvogado.cshtml
@model ADS.Core.Model.Advogado

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
    <h4>@Html.DisplayFor(model => model.Nome)</h4>
</div>
@{
    string imgSrc = null;
    if (Model.Foto != null)
    {
        var base64 = Convert.ToBase64String(Model.Foto);
        imgSrc = String.Format("data:image/gif;base64,{0}", base64);
    }

}
<div class="modal-body container">
    
    <dl class="dl-horizontal">      

        <dt>
            @if (imgSrc == null)
            {
                <img id="fotoAdvogado" src="~/Content/images/thunbnail-adv-pic.png" alt="Fot do Advogado" class="img-thumbnail vcenter" width="140" height="140">
            }
            else
            {
                <img id="fotoAdvogado" src=@imgSrc alt="Fot do Advogado" class="img-thumbnail vcenter" width="140" height="140">
            }
        </dt>
        <dd>
            <b>CPF:</b>
            @Html.DisplayFor(model => model.CPF)
            <br />
            <b>RG:</b>
            @Html.DisplayFor(model => model.RG)
            <br />
            <b>Nr.Carteira:</b>
            @Html.DisplayFor(model => model.NumeroCarteira)
            <br />
            <b>Nr.Inscrição:</b>
            @Html.DisplayFor(model => model.NumeroInscricao)
            <br />
            <b>Seccional:</b>
            @Html.DisplayFor(model => model.Seccional)
            <br />
            <b>Subseção:</b>
            @Html.DisplayFor(model => model.Subsecao)
            <br />
            <!--
            <b>Filiação:</b>
            @Html.DisplayFor(model => model.Filiacao)
            <br />
                -->
            <b>Ativo:</b>
            <span>@(Model.Ativo == true ? "Sim":"Não")</span>
            <br />
            @foreach (var m in Model.Telefone)
            {
                if (m.Removido == false)
                {
                    <b>Telefone:</b>
                    <span>(@m.DDD) @m.Numero</span>
                    <br />
                }
            }
            <br />
            @foreach (var m in Model.Endereco)
            {
                if (m.Removido==false)
                {
                    <b>CEP:</b>
                    <span>@m.CEP</span>
                    <br />
                    <b>Estado:</b>
                    <span>@m.UF</span>
                    <br />
                    <b>Cidade:</b>
                    <span>@m.Cidade</span>
                    <br />
                    <b>Bairro:</b>
                    <span>@m.Bairro</span>
                    <br />
                    <b>Logradouro:</b>
                    <span>@m.Logradouro</span>
                    <br />
                    <b>Número:</b>
                    <span>@m.Numero</span>
                    <br />
                    <b>Complemento:</b>
                    <span>@m.Complemento</span>
                    <br />
                    <br />
                }
            }
            <br />
            <b>Criado Em:</b>
            @Html.DisplayFor(model => model.CriadoEm)
        </dd>
    </dl>
</div>

ADS.Core/ADS.Core/Views/Advogado/_DetalhesEndereco.cshtml
@model ADS.Core.Model.Endereco

    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.CEP)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CEP)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.UF)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.UF)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Cidade)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Cidade)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Bairro)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Bairro)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Logradouro)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Logradouro)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Numero)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Numero)
        </dd>
        <dt>
            @Html.DisplayNameFor(model => model.Complemento)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Complemento)
        </dd>
    </dl>

ADS.Core/ADS.Core/Views/Advogado/_ListaEndereco.cshtml
@model IEnumerable<ADS.Core.Model.Endereco>

@for (var i=0; i < Model.Count(); i++) {
    if (Model.ElementAt(i).Removido == false)
    {
        <tr id="@(i+1)">
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).CEP)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Logradouro)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).UF)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Cidade)
            </td>
            <!--
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Complemento)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Bairro)
            </td>

            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Numero)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).AdvogadoId)
            </td>
                -->
            <td>
                <a href="#a" onclick="detalhesEndereco(@(i+1),@Model.ElementAt(i).EnderecoId)" class="glyphicon glyphicon-eye-open btn btn-primary btn-xs"></a>
                <a href="#a" onclick="editarEndereco(@(i+1),@Model.ElementAt(i).EnderecoId)" class="glyphicon glyphicon-pencil btn btn-primary btn-xs"></a>
                <a href="#a" onclick="removerEndereco(@(i+1),@Model.ElementAt(i).EnderecoId)" class="glyphicon glyphicon-remove btn btn-primary btn-xs"></a>
            </td>
        </tr>
    }
}

ADS.Core/ADS.Core/Views/Advogado/_ListaTelefone.cshtml
@model IEnumerable<ADS.Core.Model.Telefone>

@for (var i = 0; i < Model.Count(); i++)
{
    if (Model.ElementAt(i).Removido == false)
    {
        <tr id="@i+1">
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).DDD)
            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Numero)
            </td>
                @Html.HiddenFor(modelItem => Model.ElementAt(i).CriadoEm, new { id = "telCriadoEm" })
            <td>
                <a href="#a" onclick="editarTelefone(@(i+1),@Model.ElementAt(i).TelefoneId)" class="glyphicon glyphicon-pencil btn btn-primary btn-xs"></a>
                <a href="#a" onclick="removerTelefone(@(i+1),@Model.ElementAt(i).TelefoneId)" class="glyphicon glyphicon-remove btn btn-primary btn-xs"></a>
            </td>
        </tr>
    }
}

ADS.Core/ADS.Core/Views/Advogado/_ListaVeiculo.cshtml
@model IEnumerable<ADS.Core.Model.Veiculo>

@for (var i = 0; i < Model.Count(); i++)
{
    if (Model.ElementAt(i).Removido == false)
    {
        <tr id="@(i+1)">
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Modelo.Nome)

            </td>
            <td>
                @Html.DisplayFor(modelItem => Model.ElementAt(i).Placa)
            </td>
            <td>
                <a href="#a" onclick="editarVeiculo(@(i+1),@Model.ElementAt(i).VeiculoId)" class="glyphicon glyphicon-pencil btn btn-primary btn-xs"></a>
                <a href="#a" onclick="removerVeiculo(@(i+1),@Model.ElementAt(i).VeiculoId)" class="glyphicon glyphicon-remove btn btn-primary btn-xs"></a>
            </td>
        </tr>
    }

}